;'use strict';(function(window){var gL10nData={};var gTextProp='textContent';var gLanguage='';var gMacros={};var gReadyState='loading';var gAsyncResourceLoading=true;var gDEBUG=1;function consoleLog(message){if(gDEBUG>=2){console.log('[l10n] '+message);}};function consoleWarn(message){if(gDEBUG){console.warn('[l10n] '+message);}};function getL10nResourceLinks(){return document.querySelectorAll('link[type="application/l10n"]');}
function getL10nDictionary(){var script=document.querySelector('script[type="application/l10n"]');return script?JSON.parse(script.innerHTML):null;}
function getTranslatableChildren(element){return element?element.querySelectorAll('*[data-l10n-id]'):[];}
function getL10nAttributes(element){if(!element)
return{};var l10nId=element.getAttribute('data-l10n-id');var l10nArgs=element.getAttribute('data-l10n-args');var args={};if(l10nArgs){try{args=JSON.parse(l10nArgs);}catch(e){consoleWarn('could not parse arguments for #'+l10nId);}}
return{id:l10nId,args:args};}
function fireL10nReadyEvent(){var evtObject=document.createEvent('Event');evtObject.initEvent('localized',false,false);evtObject.language=gLanguage;window.dispatchEvent(evtObject);}
function parseResource(href,lang,successCallback,failureCallback){var baseURL=href.replace(/\/[^\/]*$/,'/');function evalString(text){if(text.lastIndexOf('\\')<0)
return text;return text.replace(/\\\\/g,'\\').replace(/\\n/g,'\n').replace(/\\r/g,'\r').replace(/\\t/g,'\t').replace(/\\b/g,'\b').replace(/\\f/g,'\f').replace(/\\{/g,'{').replace(/\\}/g,'}').replace(/\\"/g,'"').replace(/\\'/g,"'");}
function parseProperties(text){var dictionary=[];var reBlank=/^\s*|\s*$/;var reComment=/^\s*#|^\s*$/;var reSection=/^\s*\[(.*)\]\s*$/;var reImport=/^\s*@import\s+url\((.*)\)\s*$/i;var reSplit=/^([^=\s]*)\s*=\s*(.+)$/;function parseRawLines(rawText,extendedSyntax){var entries=rawText.replace(reBlank,'').split(/[\r\n]+/);var currentLang='*';var genericLang=lang.replace(/-[a-z]+$/i,'');var skipLang=false;var match='';for(var i=0;i<entries.length;i++){var line=entries[i];if(reComment.test(line))
continue;if(extendedSyntax){if(reSection.test(line)){match=reSection.exec(line);currentLang=match[1];skipLang=(currentLang!=='*')&&(currentLang!==lang)&&(currentLang!==genericLang);continue;}else if(skipLang){continue;}
if(reImport.test(line)){match=reImport.exec(line);loadImport(baseURL+match[1]);}}
var tmp=line.match(reSplit);if(tmp&&tmp.length==3){dictionary[tmp[1]]=evalString(tmp[2]);}}}
function loadImport(url){loadResource(url,function(content){parseRawLines(content,false);},null,false);}
parseRawLines(text,true);return dictionary;}
function loadResource(url,onSuccess,onFailure,asynchronous){onSuccess=onSuccess||function _onSuccess(data){};onFailure=onFailure||function _onFailure(){consoleWarn(url+' not found.');};var xhr=new XMLHttpRequest();xhr.open('GET',url,asynchronous);if(xhr.overrideMimeType){xhr.overrideMimeType('text/plain; charset=utf-8');}
xhr.onreadystatechange=function(){if(xhr.readyState==4){if(xhr.status==200||xhr.status===0){onSuccess(xhr.responseText);}else{onFailure();}}};xhr.onerror=onFailure;xhr.ontimeout=onFailure;try{xhr.send(null);}catch(e){onFailure();}}
loadResource(href,function(response){var data=parseProperties(response);for(var key in data){var id,prop,index=key.lastIndexOf('.');if(index>0){id=key.substring(0,index);prop=key.substr(index+1);}else{id=key;prop=gTextProp;}
if(!gL10nData[id]){gL10nData[id]={};}
gL10nData[id][prop]=data[key];}
if(successCallback){successCallback();}},failureCallback,gAsyncResourceLoading);};function loadLocale(lang,callback){callback=callback||function _callback(){};clear();gLanguage=lang;var langLinks=getL10nResourceLinks();var langCount=langLinks.length;if(langCount==0){var dict=getL10nDictionary();if(dict&&dict.locales&&dict.default_locale){consoleLog('using the embedded JSON directory, early way out');gL10nData=dict.locales[lang]||dict.locales[dict.default_locale];callback();}else{consoleLog('no resource to load, early way out');}
fireL10nReadyEvent(lang);gReadyState='complete';return;}
var onResourceLoaded=null;var gResourceCount=0;onResourceLoaded=function(){gResourceCount++;if(gResourceCount>=langCount){callback();fireL10nReadyEvent(lang);gReadyState='complete';}};function l10nResourceLink(link){var href=link.href;var type=link.type;this.load=function(lang,callback){var applied=lang;parseResource(href,lang,callback,function(){consoleWarn(href+' not found.');applied='';});return applied;};}
for(var i=0;i<langCount;i++){var resource=new l10nResourceLink(langLinks[i]);var rv=resource.load(lang,onResourceLoaded);if(rv!=lang){consoleWarn('"'+lang+'" resource not found');gLanguage='';}}}
function clear(){gL10nData={};gLanguage='';}
function getPluralRules(lang){var locales2rules={'af':3,'ak':4,'am':4,'ar':1,'asa':3,'az':0,'be':11,'bem':3,'bez':3,'bg':3,'bh':4,'bm':0,'bn':3,'bo':0,'br':20,'brx':3,'bs':11,'ca':3,'cgg':3,'chr':3,'cs':12,'cy':17,'da':3,'de':3,'dv':3,'dz':0,'ee':3,'el':3,'en':3,'eo':3,'es':3,'et':3,'eu':3,'fa':0,'ff':5,'fi':3,'fil':4,'fo':3,'fr':5,'fur':3,'fy':3,'ga':8,'gd':24,'gl':3,'gsw':3,'gu':3,'guw':4,'gv':23,'ha':3,'haw':3,'he':2,'hi':4,'hr':11,'hu':0,'id':0,'ig':0,'ii':0,'is':3,'it':3,'iu':7,'ja':0,'jmc':3,'jv':0,'ka':0,'kab':5,'kaj':3,'kcg':3,'kde':0,'kea':0,'kk':3,'kl':3,'km':0,'kn':0,'ko':0,'ksb':3,'ksh':21,'ku':3,'kw':7,'lag':18,'lb':3,'lg':3,'ln':4,'lo':0,'lt':10,'lv':6,'mas':3,'mg':4,'mk':16,'ml':3,'mn':3,'mo':9,'mr':3,'ms':0,'mt':15,'my':0,'nah':3,'naq':7,'nb':3,'nd':3,'ne':3,'nl':3,'nn':3,'no':3,'nr':3,'nso':4,'ny':3,'nyn':3,'om':3,'or':3,'pa':3,'pap':3,'pl':13,'ps':3,'pt':3,'rm':3,'ro':9,'rof':3,'ru':11,'rwk':3,'sah':0,'saq':3,'se':7,'seh':3,'ses':0,'sg':0,'sh':11,'shi':19,'sk':12,'sl':14,'sma':7,'smi':7,'smj':7,'smn':7,'sms':7,'sn':3,'so':3,'sq':3,'sr':11,'ss':3,'ssy':3,'st':3,'sv':3,'sw':3,'syr':3,'ta':3,'te':3,'teo':3,'th':0,'ti':4,'tig':3,'tk':3,'tl':4,'tn':3,'to':0,'tr':0,'ts':3,'tzm':22,'uk':11,'ur':3,'ve':3,'vi':0,'vun':3,'wa':4,'wae':3,'wo':0,'xh':3,'xog':3,'yo':0,'zh':0,'zu':3};function isIn(n,list){return list.indexOf(n)!==-1;}
function isBetween(n,start,end){return start<=n&&n<=end;}
var pluralRules={'0':function(n){return'other';},'1':function(n){if((isBetween((n%100),3,10)))
return'few';if(n===0)
return'zero';if((isBetween((n%100),11,99)))
return'many';if(n==2)
return'two';if(n==1)
return'one';return'other';},'2':function(n){if(n!==0&&(n%10)===0)
return'many';if(n==2)
return'two';if(n==1)
return'one';return'other';},'3':function(n){if(n==1)
return'one';return'other';},'4':function(n){if((isBetween(n,0,1)))
return'one';return'other';},'5':function(n){if((isBetween(n,0,2))&&n!=2)
return'one';return'other';},'6':function(n){if(n===0)
return'zero';if((n%10)==1&&(n%100)!=11)
return'one';return'other';},'7':function(n){if(n==2)
return'two';if(n==1)
return'one';return'other';},'8':function(n){if((isBetween(n,3,6)))
return'few';if((isBetween(n,7,10)))
return'many';if(n==2)
return'two';if(n==1)
return'one';return'other';},'9':function(n){if(n===0||n!=1&&(isBetween((n%100),1,19)))
return'few';if(n==1)
return'one';return'other';},'10':function(n){if((isBetween((n%10),2,9))&&!(isBetween((n%100),11,19)))
return'few';if((n%10)==1&&!(isBetween((n%100),11,19)))
return'one';return'other';},'11':function(n){if((isBetween((n%10),2,4))&&!(isBetween((n%100),12,14)))
return'few';if((n%10)===0||(isBetween((n%10),5,9))||(isBetween((n%100),11,14)))
return'many';if((n%10)==1&&(n%100)!=11)
return'one';return'other';},'12':function(n){if((isBetween(n,2,4)))
return'few';if(n==1)
return'one';return'other';},'13':function(n){if((isBetween((n%10),2,4))&&!(isBetween((n%100),12,14)))
return'few';if(n!=1&&(isBetween((n%10),0,1))||(isBetween((n%10),5,9))||(isBetween((n%100),12,14)))
return'many';if(n==1)
return'one';return'other';},'14':function(n){if((isBetween((n%100),3,4)))
return'few';if((n%100)==2)
return'two';if((n%100)==1)
return'one';return'other';},'15':function(n){if(n===0||(isBetween((n%100),2,10)))
return'few';if((isBetween((n%100),11,19)))
return'many';if(n==1)
return'one';return'other';},'16':function(n){if((n%10)==1&&n!=11)
return'one';return'other';},'17':function(n){if(n==3)
return'few';if(n===0)
return'zero';if(n==6)
return'many';if(n==2)
return'two';if(n==1)
return'one';return'other';},'18':function(n){if(n===0)
return'zero';if((isBetween(n,0,2))&&n!==0&&n!=2)
return'one';return'other';},'19':function(n){if((isBetween(n,2,10)))
return'few';if((isBetween(n,0,1)))
return'one';return'other';},'20':function(n){if((isBetween((n%10),3,4)||((n%10)==9))&&!(isBetween((n%100),10,19)||isBetween((n%100),70,79)||isBetween((n%100),90,99)))
return'few';if((n%1000000)===0&&n!==0)
return'many';if((n%10)==2&&!isIn((n%100),[12,72,92]))
return'two';if((n%10)==1&&!isIn((n%100),[11,71,91]))
return'one';return'other';},'21':function(n){if(n===0)
return'zero';if(n==1)
return'one';return'other';},'22':function(n){if((isBetween(n,0,1))||(isBetween(n,11,99)))
return'one';return'other';},'23':function(n){if((isBetween((n%10),1,2))||(n%20)===0)
return'one';return'other';},'24':function(n){if((isBetween(n,3,10)||isBetween(n,13,19)))
return'few';if(isIn(n,[2,12]))
return'two';if(isIn(n,[1,11]))
return'one';return'other';}};var index=locales2rules[lang.replace(/-.*$/,'')];if(!(index in pluralRules)){consoleWarn('plural form unknown for ['+lang+']');return function(){return'other';};}
return pluralRules[index];}
gMacros.plural=function(str,param,key,prop){var n=parseFloat(param);if(isNaN(n))
return str;if(prop!=gTextProp)
return str;if(!gMacros._pluralRules){gMacros._pluralRules=getPluralRules(gLanguage);}
var index='['+gMacros._pluralRules(n)+']';if(n===0&&(key+'[zero]')in gL10nData){str=gL10nData[key+'[zero]'][prop];}else if(n==1&&(key+'[one]')in gL10nData){str=gL10nData[key+'[one]'][prop];}else if(n==2&&(key+'[two]')in gL10nData){str=gL10nData[key+'[two]'][prop];}else if((key+index)in gL10nData){str=gL10nData[key+index][prop];}else if((key+'[other]')in gL10nData){str=gL10nData[key+'[other]'][prop];}
return str;};function getL10nData(key,args){var data=gL10nData[key];if(!data){consoleWarn('#'+key+' is undefined.');}
var rv={};for(var prop in data){var str=data[prop];str=substIndexes(str,args,key,prop);str=substArguments(str,args,key);rv[prop]=str;}
return rv;}
function substIndexes(str,args,key,prop){var reIndex=/\{\[\s*([a-zA-Z]+)\(([a-zA-Z]+)\)\s*\]\}/;var reMatch=reIndex.exec(str);if(!reMatch||!reMatch.length)
return str;var macroName=reMatch[1];var paramName=reMatch[2];var param;if(args&&paramName in args){param=args[paramName];}else if(paramName in gL10nData){param=gL10nData[paramName];}
if(macroName in gMacros){var macro=gMacros[macroName];str=macro(str,param,key,prop);}
return str;}
function substArguments(str,args,key){var reArgs=/\{\{\s*(.+?)\s*\}\}/;var match=reArgs.exec(str);while(match){if(!match||match.length<2)
return str;var arg=match[1];var sub='';if(args&&arg in args){sub=args[arg];}else if(arg in gL10nData){sub=gL10nData[arg][gTextProp];}else{consoleLog('argument {{'+arg+'}} for #'+key+' is undefined.');return str;}
str=str.substring(0,match.index)+sub+
str.substr(match.index+match[0].length);match=reArgs.exec(str);}
return str;}
function translateElement(element){var l10n=getL10nAttributes(element);if(!l10n.id){return;}
var data=getL10nData(l10n.id,l10n.args);if(!data){consoleWarn('#'+l10n.id+' is undefined.');return;}
if(data[gTextProp]){if(element.children.length===0){element[gTextProp]=data[gTextProp];}else{var children=element.childNodes;var found=false;for(var i=0,l=children.length;i<l;i++){if(children[i].nodeType===3&&/\S/.test(children[i].nodeValue)){if(found){children[i].nodeValue='';}else{children[i].nodeValue=data[gTextProp];found=true;}}}
if(!found){var textNode=document.createTextNode(data[gTextProp]);element.insertBefore(textNode,element.firstChild);}}
delete data[gTextProp];}
for(var k in data){element[k]=data[k];}}
function translateFragment(element){element=element||document.documentElement;var children=getTranslatableChildren(element);var elementCount=children.length;for(var i=0;i<elementCount;i++){translateElement(children[i]);}
translateElement(element);}
function l10nStartup(){gReadyState='interactive';consoleLog('loading ['+navigator.language+'] resources, '+
(gAsyncResourceLoading?'asynchronously.':'synchronously.'));if(document.documentElement.lang===navigator.language){loadLocale(navigator.language);}else{loadLocale(navigator.language,translateFragment);}}
if(typeof(document)!=='undefined'){if(document.readyState==='complete'||document.readyState==='interactive'){window.setTimeout(l10nStartup);}else{document.addEventListener('DOMContentLoaded',l10nStartup);}}
if('mozSettings'in navigator&&navigator.mozSettings){navigator.mozSettings.addObserver('language.current',function(event){loadLocale(event.settingValue,translateFragment);});}
navigator.mozL10n={get:function l10n_get(key,args,fallback){var data=getL10nData(key,args)||fallback;if(data){return'textContent'in data?data.textContent:'';}
return'{{'+key+'}}';},get language(){return{get code(){return gLanguage;},set code(lang){loadLocale(lang,translateFragment);},get direction(){var rtlList=['ar','he','fa','ps','ur'];return(rtlList.indexOf(gLanguage)>=0)?'rtl':'ltr';}};},translate:translateFragment,get dictionary(){return JSON.parse(JSON.stringify(gL10nData));},get readyState(){return gReadyState;},ready:function l10n_ready(callback){if(!callback){return;}else if(gReadyState=='complete'||gReadyState=='interactive'){window.setTimeout(callback);}else{window.addEventListener('localized',callback);}}};consoleLog('library loaded.');})(this);;'use strict';var LazyLoader=(function(){function LazyLoader(){this._loaded={};this._isLoading={};}
LazyLoader.prototype={_js:function(file,callback){var script=document.createElement('script');script.src=file;script.addEventListener('load',callback);document.head.appendChild(script);this._isLoading[file]=script;},_css:function(file,callback){var style=document.createElement('link');style.type='text/css';style.rel='stylesheet';style.href=file;document.head.appendChild(style);callback();},_html:function(domNode,callback){for(var i=0;i<domNode.childNodes.length;i++){if(domNode.childNodes[i].nodeType==document.COMMENT_NODE){domNode.innerHTML=domNode.childNodes[i].nodeValue;break;}}
callback();},load:function(files,callback){if(!Array.isArray(files))
files=[files];var loadsRemaining=files.length,self=this;function perFileCallback(file){if(self._isLoading[file])
delete self._isLoading[file];self._loaded[file]=true;if(--loadsRemaining===0){if(callback)
callback();}}
for(var i=0;i<files.length;i++){var file=files[i];if(this._loaded[file]){perFileCallback(file);}else if(this._isLoading[file]){this._isLoading[file].addEventListener('load',perFileCallback.bind(null,file));}else{var method,idx;if(typeof file==='string'){method=file.match(/\.(.*?)$/)[1];idx=file;}else{method='html';idx=file.id;}
this['_'+method](file,perFileCallback.bind(null,idx));}}}};return new LazyLoader();}());;'use strict';var idb=window.indexedDB||window.webkitIndexedDB||window.mozIndexedDB||window.msIndexedDB;IDBTransaction=IDBTransaction||{};IDBTransaction.READ_WRITE=IDBTransaction.READ_WRITE||'readwrite';IDBTransaction.READ=IDBTransaction.READ||'readonly';var Places={DEFAULT_ICON_EXPIRATION:86400000,MAX_ICON_SIZE:102400,TOP_SITE_SCREENSHOTS:4,init:function places_init(callback){this.db.open(callback);},addPlace:function places_addPlace(uri,callback){this.db.createPlace(uri,callback);},getPlace:function places_getPlace(uri,callback){this.db.getPlace(uri,callback);},addVisit:function places_addVisit(uri,callback){var visit={uri:uri,timestamp:new Date().getTime()};this.addPlace(uri,(function(){this.db.saveVisit(visit,(function(){this.updateFrecency(uri,callback);}).bind(this));}).bind(this));},updateFrecency:function places_updateFrecency(uri,callback){this.db.updatePlaceFrecency(uri,callback);},updateScreenshot:function place_updateScreenshot(uri,screenshot,callback){var maximum=this.TOP_SITE_SCREENSHOTS;this.db.getPlaceUrisByFrecency(maximum+1,(function(topSites){if(topSites.length>maximum)
var runnerUp=topSites.pop();if(topSites.indexOf(uri)==-1)
return;this.db.updatePlaceScreenshot(uri,screenshot);if(runnerUp)
this.db.updatePlaceScreenshot(runnerUp,null);}).bind(this));},addBookmark:function places_addBookmark(uri,title,callback){if(!title)
title=uri;var bookmark={uri:uri,title:title,timestamp:new Date().getTime()};this.addPlace(uri,(function(){this.db.saveBookmark(bookmark,callback);}).bind(this));},getBookmark:function places_getBookmark(uri,callback){this.db.getBookmark(uri,callback);},getBookmarks:function places_getBookmarks(callback){this.db.getAllBookmarks(callback);},removeBookmark:function places_removeBookmark(uri,callback){this.db.deleteBookmark(uri,callback);},updateBookmark:function places_updateBookmark(uri,title,callback){this.db.getBookmark(uri,(function(bookmark){if(bookmark){bookmark.title=title;this.db.saveBookmark(bookmark,callback);}else{this.addBookmark(uri,title,callback);}}).bind(this));},setPageTitle:function places_setPageTitle(uri,title,callback){this.db.updatePlaceTitle(uri,title,callback);},setPageIconUri:function places_setPageIconUri(uri,iconUri,callback){this.db.updatePlaceIconUri(uri,iconUri,callback);},setIconData:function places_setIconData(iconUri,data,callback,failed){var now=new Date().valueOf();var iconEntry={uri:iconUri,data:data,expiration:now+this.DEFAULT_ICON_EXPIRATION,failed:failed};this.db.saveIcon(iconEntry,callback);},setAndLoadIconForPage:function places_setAndLoadIconForPage(uri,iconUri,callback){this.setPageIconUri(uri,iconUri);var now=new Date().valueOf();this.db.getIcon(iconUri,(function(icon){if(icon&&icon.expiration>now)
return;var xhr=new XMLHttpRequest({mozSystem:true});xhr.open('GET',iconUri,true);xhr.responseType='blob';xhr.addEventListener('load',(function(){if(!(xhr.status===200||xhr.status===0)){this.setIconData(iconUri,null,callback,true);console.log('error downloading icon: '+xhr.status);return;}
var blob=xhr.response;if(blob.type.split('/')[0]!='image'||blob.size>this.MAX_ICON_SIZE){this.setIconData(iconUri,null,callback,true);console.log('Icon was not an image or was too big');return;}
var img=document.createElement('img');var src=window.URL.createObjectURL(blob);img.src=src;img.onload=(function(){if(img.naturalWidth>0){this.setIconData(iconUri,blob,callback);}else{this.setIconData(iconUri,null,callback,true);console.log('Icon not saved because less than 1px wide');}
window.URL.revokeObjectURL(src);}).bind(this);img.onerror=(function(){this.setIconData(iconUri,null,callback,true);console.log('Icon not saved because can not be decoded');window.URL.revokeObjectURL(src);}).bind(this);}).bind(this),false);xhr.onerror=function getIconError(){console.log('Error fetching icon');};xhr.send();}).bind(this));},getTopSites:function places_getTopSites(maximum,filter,callback){this.db.getPlacesByFrecency(maximum,filter,callback);},getHistory:function places_getHistory(callback){this.db.getHistory(20,callback);},clearHistory:function places_clearHistory(callback){this.db.getAllBookmarkUris((function(bookmarks){this.db.clearHistoryExcluding(bookmarks,callback);}).bind(this));}};Places.db={_db:null,firstRun:false,START_PAGE_URI:document.location.protocol+'//'+document.location.host+'/start.html',open:function db_open(callback){const DB_VERSION=5;const DB_NAME='browser';var request=idb.open(DB_NAME,DB_VERSION);request.onupgradeneeded=(function onUpgradeNeeded(e){this.firstRun=true;console.log('Browser database upgrade needed, upgrading.');this._db=e.target.result;this._initializeDB();}).bind(this);request.onsuccess=(function onSuccess(e){this._db=e.target.result;callback(this.firstRun);}).bind(this);request.onerror=(function onDatabaseError(e){console.log('Error opening browser database');}).bind(this);},_initializeDB:function db_initializeDB(){var db=this._db;if(db.objectStoreNames.contains('places'))
db.deleteObjectStore('places');var placesStore=db.createObjectStore('places',{keyPath:'uri'});placesStore.createIndex('frecency','frecency',{unique:false});if(db.objectStoreNames.contains('visits'))
db.deleteObjectStore('visits');var visitStore=db.createObjectStore('visits',{autoIncrement:true});visitStore.createIndex('timestamp','timestamp',{unique:false});if(db.objectStoreNames.contains('icons'))
db.deleteObjectStore('icons');db.createObjectStore('icons',{keyPath:'uri'});if(db.objectStoreNames.contains('bookmarks'))
db.deleteObjectStore('bookmarks');var bookmarkStore=db.createObjectStore('bookmarks',{keyPath:'uri'});bookmarkStore.createIndex('timestamp','timestamp',{unique:false});},createPlace:function db_createPlace(uri,callback){var transaction=this._db.transaction(['places'],IDBTransaction.READ_WRITE);var objectStore=transaction.objectStore('places');var readRequest=objectStore.get(uri);readRequest.onsuccess=function onReadSuccess(event){var place=event.target.result;if(place){if(callback)
callback();return;}else{place={uri:uri,title:uri};}
var writeRequest=objectStore.add(place);writeRequest.onsuccess=function onWriteSuccess(event){if(callback)
callback();};writeRequest.onerror=function onError(event){console.log('error writing place');};};transaction.onerror=function dbTransactionError(e){console.log('Transaction error while trying to save place '+
uri);};},getPlace:function db_getPlace(uri,callback){var db=this._db;var request=db.transaction('places').objectStore('places').get(uri);request.onsuccess=function onSuccess(event){callback(event.target.result);};request.onerror=function onError(event){if(event.target.errorCode==IDBDatabaseException.NOT_FOUND_ERR)
callback();};},updatePlace:function db_updatePlace(place,callback){var transaction=this._db.transaction(['places'],IDBTransaction.READ_WRITE);transaction.onerror=function dbTransactionError(e){console.log('Transaction error while trying to update place: '+
place.uri);};var objectStore=transaction.objectStore('places');var request=objectStore.put(place);request.onsuccess=function onSuccess(e){if(callback)
callback();};request.onerror=function onError(e){console.log('Error while updating place in global history store: '+
place.uri);};},saveVisit:function db_saveVisit(visit,callback){var transaction=this._db.transaction(['visits'],IDBTransaction.READ_WRITE);transaction.onerror=function dbTransactionError(e){console.log('Transaction error while trying to save visit');};var objectStore=transaction.objectStore('visits');var request=objectStore.add(visit);request.onerror=function onError(e){console.log('Error while adding visit to global history store');};request.onsuccess=function onSuccess(e){if(callback)
callback();};},getHistory:function db_getHistory(maximum,callback){var history=[];var db=this._db;function makeVisitProcessor(visit){return function(e){var place=e.target.result;visit.title=place.title;visit.iconUri=place.iconUri;history.push(visit);};}
var transaction=db.transaction(['visits','places']);var visitsStore=transaction.objectStore('visits');var placesStore=transaction.objectStore('places');visitsStore.openCursor(null,IDBCursor.PREV).onsuccess=function onSuccess(e){var cursor=e.target.result;if(cursor&&history.length<maximum){var visit=cursor.value;placesStore.get(visit.uri).onsuccess=makeVisitProcessor(visit);cursor.continue();}else{callback(history);}};},getPlacesByFrecency:function db_placesByFrecency(maximum,filter,callback){var topSites=[];var self=this;var transaction=self._db.transaction('places');var placesStore=transaction.objectStore('places');var frecencyIndex=placesStore.index('frecency');frecencyIndex.openCursor(null,IDBCursor.PREV).onsuccess=function onSuccess(e){var cursor=e.target.result;if(cursor&&topSites.length<maximum){var place=cursor.value;var matched=false;if(filter)
matched=self.matchesFilter(place.uri,filter)||self.matchesFilter(place.title,filter);if(matched||!filter){topSites.push(cursor.value);}
cursor.continue();}else{callback(topSites,filter);}};},matchesFilter:function db_matchesFilter(uri,filter){return uri.match(new RegExp(filter,'i'))!==null;},getPlaceUrisByFrecency:function db_getPlaceUrisByFrecency(maximum,callback){var topSites=[];var transaction=this._db.transaction('places');var placesStore=transaction.objectStore('places');var frecencyIndex=placesStore.index('frecency');frecencyIndex.openCursor(null,IDBCursor.PREV).onsuccess=function onSuccess(e){var cursor=e.target.result;if(cursor&&topSites.length<maximum){topSites.push(cursor.value.uri);cursor.continue();}else{callback(topSites);}};},clearPlaces:function db_clearPlaces(callback){var db=Places.db._db;var transaction=db.transaction('places',IDBTransaction.READ_WRITE);transaction.onerror=function dbTransactionError(e){console.log('Transaction error while trying to clear places');};var objectStore=transaction.objectStore('places');var request=objectStore.clear();request.onsuccess=function onSuccess(){callback();};request.onerror=function onError(e){console.log('Error clearing places object store');};},clearVisits:function db_clearVisits(callback){var db=Places.db._db;var transaction=db.transaction('visits',IDBTransaction.READ_WRITE);transaction.onerror=function dbTransactionError(e){console.log('Transaction error while trying to clear visits');};var objectStore=transaction.objectStore('visits');var request=objectStore.clear();request.onsuccess=function onSuccess(){if(callback)
callback();};request.onerror=function onError(e){console.log('Error clearing visits object store');};},clearIcons:function db_clearIcons(callback){var db=Places.db._db;var transaction=db.transaction('icons',IDBTransaction.READ_WRITE);transaction.onerror=function dbTransactionError(e){console.log('Transaction error while trying to clear icons');};var objectStore=transaction.objectStore('icons');var request=objectStore.clear();request.onsuccess=function onSuccess(){callback();};request.onerror=function onError(e){console.log('Error clearing icons object store');};},clearBookmarks:function db_clearBookmarks(callback){var db=Places.db._db;var transaction=db.transaction('bookmarks',IDBTransaction.READ_WRITE);transaction.onerror=function dbTransactionError(e){console.log('Transaction error while trying to clear bookmarks');};var objectStore=transaction.objectStore('bookmarks');var request=objectStore.clear();request.onsuccess=function onSuccess(){callback();};request.onerror=function onError(e){console.log('Error clearing bookmarks object store');};},saveIcon:function db_saveIcon(iconEntry,callback){var transaction=this._db.transaction(['icons'],IDBTransaction.READ_WRITE);transaction.onerror=function dbTransactionError(e){console.log('Transaction error while trying to save icon');};var objectStore=transaction.objectStore('icons');var request=objectStore.put(iconEntry);request.onsuccess=function onSuccess(e){if(callback)
callback();};request.onerror=function onError(e){console.log('Error while saving icon');};},getIcon:function db_getIcon(iconUri,callback){var request=this._db.transaction('icons').objectStore('icons').get(iconUri);request.onsuccess=function onSuccess(event){callback(event.target.result);};request.onerror=function onError(event){if(event.target.errorCode==IDBDatabaseException.NOT_FOUND_ERR)
callback();};},saveBookmark:function db_saveBookmark(bookmark,callback){var transaction=this._db.transaction(['bookmarks'],IDBTransaction.READ_WRITE);transaction.onerror=function dbTransactionError(e){console.log('Transaction error while trying to save bookmark');};var objectStore=transaction.objectStore('bookmarks');var request=objectStore.put(bookmark);request.onsuccess=function onSuccess(e){if(callback)
callback();};request.onerror=function onError(e){console.log('Error while saving bookmark');};},getBookmark:function db_getBookmark(uri,callback){var request=this._db.transaction('bookmarks').objectStore('bookmarks').get(uri);request.onsuccess=function onSuccess(event){callback(event.target.result);};request.onerror=function onError(event){if(event.target.errorCode==IDBDatabaseException.NOT_FOUND_ERR)
callback();};},deleteBookmark:function db_deleteBookmark(uri,callback){var transaction=this._db.transaction(['bookmarks'],IDBTransaction.READ_WRITE);transaction.onerror=function dbTransactionError(e){console.log('Transaction error while trying to delete bookmark');};var objectStore=transaction.objectStore('bookmarks');var request=objectStore.delete(uri);request.onsuccess=function onSuccess(event){if(callback)
callback();};request.onerror=function onError(e){console.log('Error while deleting bookmark');};},getAllBookmarks:function db_getAllBookmarks(callback){var bookmarks=[];var db=this._db;function makeBookmarkProcessor(bookmark){return function(e){var place=e.target.result;bookmark.iconUri=place.iconUri;bookmarks.push(bookmark);};}
var transaction=db.transaction(['bookmarks','places']);var bookmarksStore=transaction.objectStore('bookmarks');var bookmarksIndex=bookmarksStore.index('timestamp');var placesStore=transaction.objectStore('places');bookmarksIndex.openCursor(null,IDBCursor.PREV).onsuccess=function onSuccess(e){var cursor=e.target.result;if(cursor){var bookmark=cursor.value;placesStore.get(bookmark.uri).onsuccess=makeBookmarkProcessor(bookmark);cursor.continue();}};transaction.oncomplete=function db_bookmarkTransactionComplete(){callback(bookmarks);};},getAllBookmarkUris:function db_getAllBookmarks(callback){var uris=[];var db=this._db;var transaction=db.transaction('bookmarks');var objectStore=transaction.objectStore('bookmarks');objectStore.openCursor(null,IDBCursor.PREV).onsuccess=function onSuccess(e){var cursor=e.target.result;if(cursor){uris.push(cursor.value.uri);cursor.continue();}};transaction.oncomplete=function db_bookmarkTransactionComplete(){callback(uris);};},updatePlaceFrecency:function db_updatePlaceFrecency(uri,callback){if(uri==this.START_PAGE_URI){if(callback)
callback();return;}
var transaction=this._db.transaction(['places'],IDBTransaction.READ_WRITE);var objectStore=transaction.objectStore('places');var readRequest=objectStore.get(uri);readRequest.onsuccess=function onReadSuccess(event){var place=event.target.result;if(!place)
return;if(!place.frecency){place.frecency=1;}else{place.frecency++;}
var writeRequest=objectStore.put(place);writeRequest.onerror=function onError(){console.log('Error while saving new frecency for '+uri);};writeRequest.onsuccess=function onWriteSuccess(){if(callback)
callback();};};transaction.onerror=function dbTransactionError(e){console.log('Transaction error while trying to update place: '+
place.uri);};},resetPlaceFrecency:function db_resetPlaceFrecency(uri,callback){var transaction=this._db.transaction(['places'],IDBTransaction.READ_WRITE);var objectStore=transaction.objectStore('places');var readRequest=objectStore.get(uri);readRequest.onsuccess=function onReadSuccess(event){var place=event.target.result;if(!place)
return;place.frecency=null;var writeRequest=objectStore.put(place);writeRequest.onerror=function onError(){console.log('Error while resetting frecency for '+uri);};writeRequest.onsuccess=function onWriteSuccess(){if(callback)
callback();};};transaction.onerror=function dbTransactionError(e){console.log('Transaction error while trying to reset frecency: '+
place.uri);};},updatePlaceIconUri:function db_updatePlaceIconUri(uri,iconUri,callback){var transaction=this._db.transaction(['places'],IDBTransaction.READ_WRITE);var objectStore=transaction.objectStore('places');var readRequest=objectStore.get(uri);readRequest.onsuccess=function onReadSuccess(event){var place=event.target.result;if(place){place.iconUri=iconUri;}else{place={uri:uri,title:uri,iconUri:iconUri};}
var writeRequest=objectStore.put(place);writeRequest.onerror=function onError(){console.log('Error while saving iconUri for '+uri);};};transaction.onerror=function dbTransactionError(e){console.log('Transaction error while trying to save iconUri for '+
place.uri);};transaction.onsuccess=function dbTransactionSuccess(e){if(callback)
callback();};},updatePlaceTitle:function db_updatePlaceTitle(uri,title,callback){var transaction=this._db.transaction(['places'],IDBTransaction.READ_WRITE);var objectStore=transaction.objectStore('places');var readRequest=objectStore.get(uri);readRequest.onsuccess=function onReadSuccess(event){var place=event.target.result;if(place){place.title=title;}else{place={uri:uri,title:title};}
var writeRequest=objectStore.put(place);writeRequest.onerror=function onError(){console.log('Error while saving title for '+uri);};writeRequest.onsuccess=function onWriteSuccess(){if(callback)
callback();};};transaction.onerror=function dbTransactionError(e){console.log('Transaction error while trying to save title for '+
place.uri);};},updatePlaceScreenshot:function db_updatePlaceScreenshot(uri,screenshot,callback){var transaction=this._db.transaction(['places'],IDBTransaction.READ_WRITE);var objectStore=transaction.objectStore('places');var readRequest=objectStore.get(uri);readRequest.onsuccess=function onReadSuccess(event){var place=event.target.result;if(place){place.screenshot=screenshot;}else{place={uri:uri,title:uri,screenshot:screenshot};}
var writeRequest=objectStore.put(place);writeRequest.onerror=function onError(){console.log('Error while saving screenshot for '+uri);};writeRequest.onsuccess=function onWriteSuccess(){if(callback)
callback();};};transaction.onerror=function dbTransactionError(e){console.log('Transaction error while trying to save screenshot for '+
place.uri);};},clearHistoryExcluding:function db_clearHistoryExcluding(exceptions,callback){this.clearVisits();var transaction=this._db.transaction(['places','icons'],IDBTransaction.READ_WRITE);var placesStore=transaction.objectStore('places');var iconStore=transaction.objectStore('icons');placesStore.openCursor(null,IDBCursor.PREV).onsuccess=function onSuccess(e){var cursor=e.target.result;if(cursor){var place=cursor.value;if(exceptions.indexOf(place.uri)==-1){placesStore.delete(place.uri);if(place.iconUri){iconStore.delete(place.iconUri);}}else{Places.db.resetPlaceFrecency(place.uri);}
cursor.continue();}};transaction.oncomplete=function db_bookmarkTransactionComplete(){if(callback)
callback();};}};;'use strict';var rscheme=/^(?:[a-z\u00a1-\uffff0-9-+]+)(?::|:\/\/)/i;var _=navigator.mozL10n.get;var Browser={currentTab:null,tabCounter:0,tabs:{},styleSheet:document.styleSheets[0],cssTranslateId:null,GO:0,REFRESH:1,STOP:2,SEARCH:3,VISIBLE:0,TRANSITIONING:1,HIDDEN:2,PAGE_SCREEN:'page-screen',TABS_SCREEN:'tabs-screen',AWESOME_SCREEN:'awesome-screen',SETTINGS_SCREEN:'settings-screen',previousScreen:null,currentScreen:'page-screen',DEFAULT_SEARCH_PROVIDER_URL:'www.google.com',DEFAULT_SEARCH_PROVIDER_TITLE:'Google',DEFAULT_SEARCH_PROVIDER_ICON:'http://www.google.com/favicon.ico',DEFAULT_FAVICON:'style/images/favicon.png',ABOUT_PAGE_URL:document.location.protocol+'//'+document.location.host+'/about.html',UPPER_SCROLL_THRESHOLD:50,LOWER_SCROLL_THRESHOLD:5,MAX_TOP_SITES:4,MAX_THUMBNAIL_WIDTH:140,MAX_THUMBNAIL_HEIGHT:100,FIRST_TAB:'tab_0',urlButtonMode:null,addressBarState:null,inTransition:false,waitingActivities:[],hasLoaded:false,init:function browser_init(){this.getAllElements();window.addEventListener('resize',this.handleWindowResize.bind(this));this.backButton.addEventListener('click',this.goBack.bind(this));this.forwardButton.addEventListener('click',this.goForward.bind(this));this.bookmarkButton.addEventListener('click',this.showBookmarkMenu.bind(this));this.urlBar.addEventListener('submit',this.handleUrlFormSubmit.bind(this));this.urlInput.addEventListener('focus',this.urlFocus.bind(this));this.urlInput.addEventListener('mouseup',this.urlMouseUp.bind(this));this.urlInput.addEventListener('keyup',this.handleUrlInputKeypress.bind(this));this.urlButton.addEventListener('click',this.handleUrlFormSubmit.bind(this));this.tabsBadge.addEventListener('click',this.handleTabsBadgeClicked.bind(this));Places.init((function(firstRun){this.selectTab(this.createTab());if(firstRun)
this.populateDefaultData();this.addressBarState=this.VISIBLE;}).bind(this));},toCamelCase:function toCamelCase(str){return str.replace(/\-(.)/g,function replacer(str,p1){return p1.toUpperCase();});},getAllElements:function browser_getAllElements(){var elementIDs=['toolbar-start','url-bar','url-input','url-button','awesomescreen','back-button','forward-button','bookmark-button','ssl-indicator','tabs-badge','throbber','frames','main-screen','crashscreen','bookmark-menu','bookmark-entry-sheet','awesomescreen-cancel-button','startscreen','top-site-thumbnails','no-top-sites','tray'];elementIDs.forEach(function createElementRef(name){this[this.toCamelCase(name)]=document.getElementById(name);},this);},loadRemaining:function browser_loadRemaining(){if(this.hasLoaded)
return;console.log('----------loadink!');var elementsToLoad=[this.awesomescreen,this.crashscreen,this.tray,this.bookmarkMenu,this.bookmarkEntrySheet,document.getElementById('settings'),document.getElementById('modal-dialog-alert'),document.getElementById('modal-dialog-prompt'),document.getElementById('modal-dialog-confirm'),document.getElementById('modal-dialog-custom-prompt'),document.getElementById('http-authentication-dialog')];var filesToLoad=['shared/style/headers.css','shared/style/buttons.css','shared/style/input_areas.css','shared/style/status.css','shared/style/confirm.css','style/action_menu.css','style/authentication_dialog.css','shared/js/gesture_detector.js'];var jsFiles=['js/date_helper.js','js/modal_dialog.js','js/authentication_dialog.js','js/browser_extensions.js'];var domElements=['tab-headers','top-sites','bookmarks','history','top-sites-tab','bookmarks-tab','history-tab','tabs-list','settings-button','settings-done-button','about-browser-button','clear-history-button','close-tab','try-reloading','bookmark-menu-add','bookmark-menu-remove','bookmark-menu-cancel','bookmark-menu-edit','bookmark-entry-sheet-cancel','bookmark-entry-sheet-done','bookmark-title','bookmark-url','bookmark-previous-url','bookmark-menu-add-home','new-tab-button','clear-private-data-button','results','tab-panels'];var loadBrowserFiles=function(){LazyLoader.load(jsFiles,function(){var mozL10n=navigator.mozL10n;mozL10n.ready(function browser_localizeElements(){elementsToLoad.forEach(function l10nElement(element){mozL10n.translate(element);});});domElements.forEach(function createElementRef(name){this[this.toCamelCase(name)]=document.getElementById(name);},this);this.initRemainingListeners();this.hasLoaded=true;if(this.waitingActivities.length){this.waitingActivities.forEach(this.handleActivity,this);}}.bind(this));}
LazyLoader.load(elementsToLoad.concat(filesToLoad),loadBrowserFiles.bind(this));},initRemainingListeners:function browser_initRemainingListeners(){this.tabPanels.addEventListener('click',this.followLink.bind(this));this.results.addEventListener('click',this.followLink.bind(this));this.topSitesTab.addEventListener('click',this.showTopSitesTab.bind(this));this.bookmarksTab.addEventListener('click',this.showBookmarksTab.bind(this));this.historyTab.addEventListener('click',this.showHistoryTab.bind(this));this.settingsButton.addEventListener('click',this.showSettingsScreen.bind(this));this.newTabButton.addEventListener('click',this.handleNewTab.bind(this));this.settingsDoneButton.addEventListener('click',this.showPageScreen.bind(this));this.aboutBrowserButton.addEventListener('click',this.showAboutPage.bind(this));this.clearHistoryButton.addEventListener('click',this.handleClearHistory.bind(this));this.closeTab.addEventListener('click',this.handleCloseTab.bind(this));this.tryReloading.addEventListener('click',this.handleTryReloading.bind(this));this.bookmarkMenuAdd.addEventListener('click',this.addBookmark.bind(this));this.bookmarkMenuRemove.addEventListener('click',this.removeBookmark.bind(this));this.bookmarkMenuCancel.addEventListener('click',this.hideBookmarkMenu.bind(this));this.bookmarkMenuEdit.addEventListener('click',this.showBookmarkEntrySheet.bind(this));this.bookmarkMenuAddHome.addEventListener('click',this.addLinkToHome.bind(this));this.bookmarkEntrySheetCancel.addEventListener('click',this.hideBookmarkEntrySheet.bind(this));this.bookmarkEntrySheetDone.addEventListener('click',this.saveBookmark.bind(this));this.awesomescreenCancelButton.addEventListener('click',this.handleAwesomescreenCancel.bind(this));this.topSiteThumbnails.addEventListener('click',this.followLink.bind(this));this.clearPrivateDataButton.addEventListener('click',this.clearPrivateData.bind(this));this.tabsSwipeMngr.browser=this;['mousedown','pan','tap','swipe'].forEach(function(evt){this.tabsList.addEventListener(evt,this.tabsSwipeMngr[evt].bind(this.tabsSwipeMngr));},this);this.screenSwipeMngr.browser=this;this.screenSwipeMngr.screen=this.mainScreen;this.screenSwipeMngr.gestureDetector=new GestureDetector(this.mainScreen);['mousedown','pan','tap','swipe'].forEach(function(evt){this.mainScreen.addEventListener(evt,this.screenSwipeMngr[evt].bind(this.screenSwipeMngr));},this);document.addEventListener('mozvisibilitychange',this.handleVisibilityChange.bind(this));this.handleWindowResize();ModalDialog.init();AuthenticationDialog.init(false);},populateDefaultData:function browser_populateDefaultData(){console.log('Populating default data.');var DEFAULT_BOOKMARK='000000';var iccSettings={mcc:'-1',mnc:'-1'};function getICCSettings(callback,data){var transaction=navigator.mozSettings.createLock();var mccKey='operatorvariant.mcc';var mncKey='operatorvariant.mnc';var mccRequest=transaction.get(mccKey);mccRequest.onsuccess=function(){iccSettings.mcc=mccRequest.result[mccKey]||'0';var mncRequest=transaction.get(mncKey);mncRequest.onsuccess=function(){iccSettings.mnc=mncRequest.result[mncKey]||'0';callback(data);};};}
function addDefaultBookmarks(data){data.bookmarks.forEach(function browser_addDefaultBookmarks(bookmark){Places.addBookmark(bookmark.uri,bookmark.title);if(bookmark.iconUri)
Places.setAndLoadIconForPage(bookmark.uri,bookmark.iconUri);});}
function zfill(code,len){var c=code;while(c.length<len)c='0'+c;return c;}
function customizeDefaultBookmark(data){var DEFAULT_MNC='000';var codename=DEFAULT_BOOKMARK;var pad_mcc=zfill(iccSettings.mcc,3);var pad_mnc=zfill(iccSettings.mnc,3);if(data[pad_mcc+pad_mnc]){codename=pad_mcc+pad_mnc;}else if(data[pad_mcc+DEFAULT_MNC]){codename=pad_mcc+DEFAULT_MNC;}
addDefaultBookmarks(data[codename]);}
var xhr=new XMLHttpRequest();xhr.open('GET','/js/init.json',true);xhr.addEventListener('load',(function browser_defaultDataListener(){if(!(xhr.status===200|xhr.status===0))
return;var data=JSON.parse(xhr.responseText);if(data[DEFAULT_BOOKMARK]){getICCSettings(customizeDefaultBookmark,data);}else{console.log('No default bookmark.');}}).bind(this),false);xhr.onerror=function getDefaultDataError(){console.log('Error getting default data.');};xhr.send();},handlePageScreenClicked:function browser_handlePageScreenClicked(e){if(this.inTransition){return;}
if(this.currentScreen===this.TABS_SCREEN){this.showPageScreen();}},handleTryReloading:function browser_handleTryReloading(){this.reviveCrashedTab(this.currentTab);},handleCloseTab:function browser_handleCloseTab(){if(Object.keys(this.tabs).length==1)
return;this.hideCrashScreen();this.deleteTab(this.currentTab.id);this.setTabVisibility(this.currentTab,true);this.updateTabsCount();},handleWindowResize:function browser_handleWindowResize(){var leftPos='translate('+-(window.innerWidth-50)+'px)';if(!this.gutterPosRule){var css='.tabs-screen #main-screen { transform: '+leftPos+'; }';var insertId=this.styleSheet.cssRules.length-1;this.gutterPosRule=this.styleSheet.insertRule(css,insertId);}else{var rule=this.styleSheet.cssRules[this.gutterPosRule];rule.style.transform=leftPos;}},handleTabsBadgeClicked:function browser_handleTabsBadgeClicked(e){if(this.inTransition)
return;this.showTabScreen();},handleAwesomescreenCancel:function browser_handleAwesomescreenCancel(e){if(this.previousScreen===this.PAGE_SCREEN){this.showPageScreen();}else{this.deleteTab(this.currentTab.id);this.showTabScreen();}
this.updateSecurityIcon();},handleNewTab:function browserHandleNewTab(e){this.inTransition=true;var tabId=this.createTab();this.showNewTabAnimation((function browser_showNewTabAnimation(){this.selectTab(tabId);this.showAwesomeScreen();}).bind(this));},handleBrowserEvent:function browser_handleBrowserEvent(tab){return(function(evt){var isCurrentTab=this.currentTab.id===tab.id;switch(evt.type){case'mozbrowserloadstart':if(!tab.url||tab.crashed){return;}
if(this.addressBarState===this.HIDDEN){this.showAddressBar();}
tab.loading=true;if(isCurrentTab&&this.currentScreen===this.PAGE_SCREEN){this.throbber.classList.add('loading');this.setUrlButtonMode(this.STOP);}
tab.title=null;tab.iconUrl=null;break;case'mozbrowserloadend':if(!tab.loading){return;}
tab.loading=false;if(isCurrentTab&&this.currentScreen===this.PAGE_SCREEN){this.throbber.classList.remove('loading');this.setUrlBar(tab.title||tab.url);this.setUrlButtonMode(this.REFRESH);}
if(tab.dom.getScreenshot){tab.dom.getScreenshot(this.MAX_THUMBNAIL_WIDTH,this.MAX_THUMBNAIL_HEIGHT).onsuccess=(function(e){tab.screenshot=e.target.result;if(this.currentScreen===this.TABS_SCREEN){this.showTabScreen();}
Places.updateScreenshot(tab.url,tab.screenshot);}).bind(this);}
if(!tab.iconUrl){var a=document.createElement('a');a.href=tab.url;var iconUrl=a.protocol+'//'+a.hostname+'/'+'favicon.ico';Places.setAndLoadIconForPage(tab.url,iconUrl);}
break;case'mozbrowserlocationchange':if(evt.detail==='about:blank'){return;}
tab.url=evt.detail;this.updateHistory(evt.detail);if(isCurrentTab){if(this.currentScreen===this.PAGE_SCREEN){this.setUrlBar(tab.url);}}
break;case'mozbrowsertitlechange':if(evt.detail){tab.title=evt.detail;Places.setPageTitle(tab.url,tab.title);if(isCurrentTab&&!tab.loading&&this.currentScreen===this.PAGE_SCREEN){this.setUrlBar(tab.title);}
if(this.currentScreen===this.TABS_SCREEN){this.showTabScreen();}}
break;case'mozbrowsericonchange':if(evt.detail&&evt.detail!=tab.iconUrl){tab.iconUrl=evt.detail;Places.setAndLoadIconForPage(tab.url,tab.iconUrl);}
break;case'mozbrowsercontextmenu':this.showContextMenu(evt);break;case'mozbrowsersecuritychange':tab.security=evt.detail;if(isCurrentTab){this.updateSecurityIcon();}
break;case'mozbrowseropenwindow':this.handleWindowOpen(evt);break;case'mozbrowserclose':this.handleWindowClose(tab.id);this.setTabVisibility(this.currentTab,true);this.updateTabsCount();if(tab.id===ModalDialog.currentOrigin){ModalDialog.hide();}else if(tab.id===AuthenticationDialog.currentOrigin){AuthenticationDialog.hide();}
break;case'mozbrowserusernameandpasswordrequired':if(!isCurrentTab){this.hideCurrentTab();this.selectTab(tab.id);}
if(this.currentScreen!==this.PAGE_SCREEN){this.showPageScreen();}
AuthenticationDialog.handleEvent(evt,tab.id);break;case'mozbrowsershowmodalprompt':if(!isCurrentTab){this.hideCurrentTab();this.selectTab(tab.id);}
if(this.currentScreen!==this.PAGE_SCREEN){this.showPageScreen();}
ModalDialog.handleEvent(evt,tab.id);break;case'mozbrowsererror':if(evt.detail.type==='fatal')
this.handleCrashedTab(tab);break;case'mozbrowserasyncscroll':this.handleScroll(evt);break;}}).bind(this);},handleScroll:function browser_handleScroll(evt){if(evt.detail.top<this.LOWER_SCROLL_THRESHOLD){if(this.addressBarState===this.VISIBLE||this.addressBarState===this.TRANSITIONING){return;}
this.showAddressBar();}else if(evt.detail.top>this.UPPER_SCROLL_THRESHOLD){if(this.addressBarState===this.HIDDEN||this.addressBarState===this.TRANSITIONING){return;}
this.hideAddressBar();}},hideAddressBar:function browser_hideAddressBar(){var addressBarHidden=(function browser_addressBarHidden(){this.addressBarState=this.HIDDEN;this.mainScreen.removeEventListener('transitionend',addressBarHidden);}).bind(this);this.mainScreen.addEventListener('transitionend',addressBarHidden);this.addressBarState=this.TRANSITIONING;this.mainScreen.classList.add('expanded');this.mainScreen.clientTop;this.mainScreen.classList.add('address-hidden');},showAddressBar:function browser_showAddressBar(){var addressBarVisible=(function browser_addressBarVisible(){this.mainScreen.classList.remove('expanded');this.addressBarState=this.VISIBLE;this.mainScreen.removeEventListener('transitionend',addressBarVisible);}).bind(this);this.mainScreen.addEventListener('transitionend',addressBarVisible);this.addressBarState=this.TRANSITIONING;this.mainScreen.clientTop;this.mainScreen.classList.remove('address-hidden');},handleUrlInputKeypress:function browser_handleUrlInputKeypress(evt){var input=this.urlInput.value;this.setUrlButtonMode(this.isNotURL(input)?this.SEARCH:this.GO);this.updateAwesomeScreen(input);},showCrashScreen:function browser_showCrashScreen(){if(Object.keys(this.tabs).length>1){this.closeTab.removeAttribute('disabled');}else{this.closeTab.setAttribute('disabled','disabled');}
this.crashscreen.style.display='block';},hideCrashScreen:function browser_hideCrashScreen(){this.crashscreen.style.display='none';},handleCrashedTab:function browser_handleCrashedTab(tab){if(tab.id===this.currentTab.id&&!document.mozHidden){this.showCrashScreen();}
tab.loading=false;tab.crashed=true;ModalDialog.clear(tab.id);AuthenticationDialog.clear(tab.id);this.frames.removeChild(tab.dom);delete tab.dom;delete tab.screenshot;tab.loading=false;},handleVisibilityChange:function browser_handleVisibilityChange(){if(!document.mozHidden&&this.currentTab.crashed)
this.reviveCrashedTab(this.currentTab);if(document.mozHidden){this.urlInput.blur();this.currentTab.dom.blur();}},reviveCrashedTab:function browser_reviveCrashedTab(tab){this.createTab(null,null,tab);this.setTabVisibility(tab,true);this.refreshButtons();this.navigate(tab.url);tab.crashed=false;this.hideCrashScreen();},handleWindowOpen:function browser_handleWindowOpen(evt){var url=evt.detail.url;var frame=evt.detail.frameElement;var tab=this.createTab(url,frame);this.hideCurrentTab();this.selectTab(tab);this.currentTab.loading=true;this.setTabVisibility(this.currentTab,true);this.updateTabsCount();},handleWindowClose:function browser_handleWindowClose(tabId){if(!tabId)
return false;this.deleteTab(tabId);return true;},updateTabsCount:function browser_updateTabsCount(){this.tabsBadge.innerHTML=Object.keys(this.tabs).length+'<span id="more-tabs">&#x203A;</span>';},updateSecurityIcon:function browser_updateSecurityIcon(){if(!this.currentTab.security){this.sslIndicator.value='';return;}
this.sslIndicator.value=this.currentTab.security.state;},navigate:function browser_navigate(url){this.hideStartscreen();this.showPageScreen();this.currentTab.title=null;this.currentTab.url=url;this.currentTab.dom.setAttribute('src',url);this.setUrlBar(url);},getUrlFromInput:function browser_getUrlFromInput(input){var hasScheme=!!(rscheme.exec(input)||[])[0];if(this.isNotURL(input)){return'http://'+this.DEFAULT_SEARCH_PROVIDER_URL+'/search?q='+input;}
if(!hasScheme){return'http://'+input;}
return input;},handleUrlFormSubmit:function browser_handleUrlFormSubmit(e){if(e){e.preventDefault();}
if(this.urlButtonMode==this.REFRESH&&this.currentTab.crashed){this.setUrlBar(this.currentTab.url);this.reviveCrashedTab(this.currentTab);return;}
if(this.urlButtonMode==this.REFRESH&&!this.currentTab.crashed){this.currentTab.dom.reload(false);return;}
if(this.urlButtonMode==this.STOP&&!this.currentTab.crashed){this.currentTab.dom.stop();return;}
var url=this.getUrlFromInput(this.urlInput.value);if(url!==this.currentTab.url){this.setUrlBar(url);this.currentTab.url=url;}
this.urlInput.blur();if(this.currentTab.crashed){this.reviveCrashedTab(this.currentTab);return;}
this.navigate(url);},goBack:function browser_goBack(){this.currentTab.dom.goBack();},goForward:function browser_goForward(){this.currentTab.dom.goForward();},addBookmark:function browser_addBookmark(e){e.preventDefault();if(!this.currentTab.url)
return;Places.addBookmark(this.currentTab.url,this.currentTab.title,this.refreshBookmarkButton.bind(this));this.hideBookmarkMenu();},removeBookmark:function browser_removeBookmark(e){e.preventDefault();if(!this.currentTab.url)
return;Places.removeBookmark(this.currentTab.url,this.refreshBookmarkButton.bind(this));this.hideBookmarkMenu();},showBookmarkMenu:function browser_showBookmarkMenu(){if(!this.currentTab.url)
return;this.bookmarkMenu.classList.remove('hidden');Places.getBookmark(this.currentTab.url,(function(bookmark){if(bookmark){this.bookmarkMenuAdd.parentNode.classList.add('hidden');this.bookmarkMenuRemove.parentNode.classList.remove('hidden');this.bookmarkMenuEdit.parentNode.classList.remove('hidden');}else{this.bookmarkMenuAdd.parentNode.classList.remove('hidden');this.bookmarkMenuRemove.parentNode.classList.add('hidden');this.bookmarkMenuEdit.parentNode.classList.add('hidden');}}).bind(this));},hideBookmarkMenu:function browser_hideBookmarkMenu(){this.bookmarkMenu.classList.add('hidden');},refreshBookmarkButton:function browser_refreshBookmarkButton(){if(!this.currentTab.url)
return;Places.getBookmark(this.currentTab.url,(function(bookmark){if(bookmark){this.bookmarkButton.classList.add('bookmarked');}else{this.bookmarkButton.classList.remove('bookmarked');}}).bind(this));},showBookmarkEntrySheet:function browser_showBookmarkEntrySheet(){if(!this.currentTab.url)
return;this.hideBookmarkMenu();this.bookmarkEntrySheet.classList.remove('hidden');Places.getBookmark(this.currentTab.url,(function(bookmark){if(!bookmark){this.hideBookmarkEntrySheet();return;}
this.bookmarkTitle.value=bookmark.title;this.bookmarkUrl.value=bookmark.uri;this.bookmarkPreviousUrl.value=bookmark.uri;}).bind(this));},hideBookmarkEntrySheet:function browser_hideBookmarkEntrySheet(){this.bookmarkEntrySheet.classList.add('hidden');this.bookmarkTitle.value='';this.bookmarkUrl.value='';this.bookmarkPreviousUrl.value='';},saveBookmark:function browser_saveBookmark(){var url=this.bookmarkUrl.value;var title=this.bookmarkTitle.value;var previousUrl=this.bookmarkPreviousUrl.value;if(url!=previousUrl){Places.removeBookmark(previousUrl,this.refreshBookmarkButton.bind(this));Places.updateBookmark(url,title);}else{Places.updateBookmark(url,title);}
this.hideBookmarkEntrySheet();},addLinkToHome:function browser_addLinkToHome(){if(!this.currentTab.url)
return;Places.getPlace(this.currentTab.url,(function(place){new MozActivity({name:'save-bookmark',data:{type:'url',url:this.currentTab.url,name:this.currentTab.title,icon:place.iconUri,useAsyncPanZoom:true}});}).bind(this));this.hideBookmarkMenu();},refreshButtons:function browser_refreshButtons(){if(!this.currentTab.dom.getCanGoBack)
return;this.currentTab.dom.getCanGoBack().onsuccess=(function(e){this.backButton.disabled=!e.target.result;}).bind(this);this.currentTab.dom.getCanGoForward().onsuccess=(function(e){this.forwardButton.disabled=!e.target.result;}).bind(this);this.refreshBookmarkButton();},updateHistory:function browser_updateHistory(url){Places.addVisit(url);this.refreshButtons();},shouldFocus:false,urlMouseUp:function browser_urlMouseUp(e){if(this.shouldFocus){e.preventDefault();this.urlInput.focus();this.urlInput.select();this.shouldFocus=false;}},urlFocus:function browser_urlFocus(e){if(this.currentScreen===this.PAGE_SCREEN){ModalDialog.hide();AuthenticationDialog.hide();this.urlInput.value=this.currentTab.url;this.sslIndicator.value='';this.setUrlBar(this.currentTab.url);this.showAwesomeScreen();this.shouldFocus=true;}else if(this.currentScreen===this.AWESOME_SCREEN){this.shouldFocus=true;}},setUrlBar:function browser_setUrlBar(data){if(this.currentTab.url==this.ABOUT_PAGE_URL){this.urlInput.value='';}else{this.urlInput.value=data;}},setUrlButtonMode:function browser_setUrlButtonMode(mode){this.urlButtonMode=mode;switch(mode){case this.GO:this.urlButton.style.backgroundImage='url(style/images/go.png)';break;case this.REFRESH:this.urlButton.style.backgroundImage='url(style/images/refresh.png)';break;case this.STOP:this.urlButton.style.backgroundImage='url(style/images/stop.png)';break;case this.SEARCH:this.urlButton.style.backgroundImage='url(style/images/search.png)';break;}},deselectAwesomescreenTabs:function browser_deselectAwesomescreenTabs(){this.topSites.classList.remove('selected');this.topSitesTab.classList.remove('selected');this.bookmarks.classList.remove('selected');this.bookmarksTab.classList.remove('selected');this.history.classList.remove('selected');this.historyTab.classList.remove('selected');},updateAwesomeScreen:function browser_updateAwesomeScreen(filter){if(!filter){this.results.classList.add('hidden');filter=false;}else{this.results.classList.remove('hidden');}
Places.getTopSites(20,filter,this.showResults.bind(this));},showResults:function browser_showResults(visited,filter){this.results.innerHTML='';var list=document.createElement('ul');list.setAttribute('role','listbox');this.results.appendChild(list);visited.forEach(function browser_processResult(data){this.drawAwesomescreenListItem(list,data,filter);},this);if(visited.length<2&&filter){var data={title:this.DEFAULT_SEARCH_PROVIDER_TITLE,uri:'http://'+this.DEFAULT_SEARCH_PROVIDER_URL+'/search?q='+filter,iconUri:this.DEFAULT_SEARCH_PROVIDER_ICON,description:_('search-for')+' "'+filter+'"'};this.drawAwesomescreenListItem(list,data);}},showTopSitesTab:function browser_showTopSitesTab(){this.deselectAwesomescreenTabs();this.topSitesTab.classList.add('selected');this.topSites.classList.add('selected');Places.getTopSites(20,null,this.showTopSites.bind(this));},showTopSites:function browser_showTopSites(topSites){this.topSites.innerHTML='';var list=document.createElement('ul');list.setAttribute('role','listbox');this.topSites.appendChild(list);topSites.forEach(function browser_processTopSite(data){this.drawAwesomescreenListItem(list,data);},this);},showHistoryTab:function browser_showHistoryTab(){this.deselectAwesomescreenTabs();this.historyTab.classList.add('selected');this.history.classList.add('selected');Places.getHistory(this.showGlobalHistory.bind(this));},showGlobalHistory:function browser_showGlobalHistory(visits){this.history.innerHTML='';var thresholds=[new Date().valueOf(),DateHelper.todayStarted(),DateHelper.yesterdayStarted(),DateHelper.thisWeekStarted(),DateHelper.thisMonthStarted(),DateHelper.lastSixMonthsStarted(),0];var threshold=0;var month=null;var year=null;var urls=[];visits.forEach(function browser_processVisit(visit){var timestamp=visit.timestamp;if(timestamp>0&&timestamp<thresholds[threshold]){urls=[];threshold=this.incrementHistoryThreshold(timestamp,threshold,thresholds);if(threshold!=5)
this.drawHistoryHeading(threshold);}
if(threshold==5){var timestampDate=new Date(timestamp);if(timestampDate.getMonth()!=month||timestampDate.getFullYear()!=year){urls=[];month=timestampDate.getMonth();year=timestampDate.getFullYear();this.drawHistoryHeading(threshold,timestamp);}}
if(urls.indexOf(visit.uri)==-1){urls.push(visit.uri);this.drawAwesomescreenListItem(this.history.lastChild,visit);}},this);},incrementHistoryThreshold:function browser_incrementHistoryThreshold(timestamp,currentThreshold,thresholds){var newThreshold=currentThreshold+=1;if(timestamp<thresholds[newThreshold])
return browser_incrementHistoryThreshold(timestamp,newThreshold,thresholds);return newThreshold;},drawAwesomescreenListItem:function browser_drawAwesomescreenListItem(list,data,filter){var entry=document.createElement('li');var link=document.createElement('a');var title=document.createElement('h5');var url=document.createElement('small');entry.setAttribute('role','listitem');link.href=data.uri;var titleText=data.title?data.title:data.url;title.innerHTML=Utils.createHighlightHTML(titleText,filter);if(data.uri==this.ABOUT_PAGE_URL){url.textContent='about:';}else if(data.description){url.innerHTML=Utils.createHighlightHTML(data.description);}else{url.innerHTML=Utils.createHighlightHTML(data.uri,filter);}
link.appendChild(title);link.appendChild(url);entry.appendChild(link);list.appendChild(entry);if(!data.iconUri){link.style.backgroundImage='url('+this.DEFAULT_FAVICON+')';return;}
Places.db.getIcon(data.iconUri,(function(icon){if(icon&&icon.failed!=true&&icon.data){var imgUrl=window.URL.createObjectURL(icon.data);link.style.backgroundImage='url('+imgUrl+')';}else{link.style.backgroundImage='url('+this.DEFAULT_FAVICON+')';}}).bind(this));},drawHistoryHeading:function browser_drawHistoryHeading(threshold,timestamp){var LABELS=['future','today','yesterday','last-7-days','this-month','last-6-months','older-than-6-months'];var text='';var h3=document.createElement('h3');if(threshold==5&&timestamp){var date=new Date(timestamp);var now=new Date();text=_('month-'+date.getMonth());if(date.getFullYear()!=now.getFullYear())
text+=' '+date.getFullYear();}else{text=_(LABELS[threshold]);}
var textNode=document.createTextNode(text);var ul=document.createElement('ul');ul.setAttribute('role','listbox');h3.appendChild(textNode);this.history.appendChild(h3);this.history.appendChild(ul);},showBookmarksTab:function browser_showBookmarksTab(){this.deselectAwesomescreenTabs();this.bookmarksTab.classList.add('selected');this.bookmarks.classList.add('selected');Places.getBookmarks(this.showBookmarks.bind(this));},showBookmarks:function browser_showBookmarks(bookmarks){this.bookmarks.innerHTML='';var list=document.createElement('ul');list.setAttribute('role','listbox');this.bookmarks.appendChild(list);bookmarks.forEach(function browser_processBookmark(data){this.drawAwesomescreenListItem(list,data);},this);},openInNewTab:function browser_openInNewTab(url){this.createTab(url);this.updateTabsCount();},generateSystemMenuItem:function browser_generateSystemMenuItem(item){var self=this;if(item.nodeName==='A'){return{label:_('open-in-new-tab'),callback:function(){self.openInNewTab(item.data);}};}
return false;},showContextMenu:function browser_showContextMenu(evt){var menuItems=[];var menuData=evt.detail;var dialog=document.createElement('section');var menu=document.createElement('menu');var list=document.createElement('ul');evt.detail.systemTargets.forEach(function(item){var action=this.generateSystemMenuItem(item);if(action){menuItems.push(action);}},this);var collectMenuItems=function(menu){menu.items.forEach(function(item){if(item.type==='menuitem'){menuItems.push({icon:item.icon,label:item.label,callback:function(){evt.detail.contextMenuItemSelected(item.id);}});}else if(item.type==='menu'){collectMenuItems(item);}});};if(menuData.contextmenu){collectMenuItems(menuData.contextmenu);}
if(Object.keys(menuItems).length===0){return;}
menuItems.forEach(function(menuitem){var li=document.createElement('li');var button=this.createButton(menuitem.label,menuitem.icon);button.addEventListener('click',function(){document.body.removeChild(dialog);menuitem.callback();});li.appendChild(button);list.appendChild(li);},this);var cancel=document.createElement('li');cancel.appendChild(this.createButton('Cancel'));list.appendChild(cancel);cancel.addEventListener('click',function(e){document.body.removeChild(dialog);});menu.classList.add('actions');menu.appendChild(list);dialog.setAttribute('role','dialog');dialog.appendChild(menu);document.body.appendChild(dialog);},createButton:function browser_createButton(text,image){var button=document.createElement('button');var textNode=document.createTextNode(text);if(image){var img=document.createElement('img');img.setAttribute('src',image);button.appendChild(img);}
button.appendChild(textNode);return button;},followLink:function browser_followLink(e){e.preventDefault();if(e.target.nodeName==='A'){this.navigate(e.target.getAttribute('href'));this.hideStartscreen();}},setTabVisibility:function(tab,visible){if(!tab.dom)
return;if(ModalDialog.originHasEvent(tab.id)){if(visible){ModalDialog.show(tab.id);}else{ModalDialog.hide();}}
if(AuthenticationDialog.originHasEvent(tab.id)){if(visible){AuthenticationDialog.show(tab.id);}else{AuthenticationDialog.hide();}}
this.setVisibleWrapper(tab,visible);tab.dom.style.display=visible?'block':'none';tab.dom.style.top='0px';},setVisibleWrapper:function(tab,visible){if(tab.setVisibleTimeout){clearTimeout(tab.setVisibleTimeout);}
if(tab.dom.setVisible){tab.dom.setVisible(visible);return;}
tab.setVisibleTimeout=setTimeout(function(){if(tab.dom.setVisible)
tab.dom.setVisible(visible);});},bindBrowserEvents:function browser_bindBrowserEvents(iframe,tab){var browserEvents=['loadstart','loadend','locationchange','titlechange','iconchange','contextmenu','securitychange','openwindow','close','showmodalprompt','error','asyncscroll','usernameandpasswordrequired'];browserEvents.forEach(function attachBrowserEvent(type){iframe.addEventListener('mozbrowser'+type,this.handleBrowserEvent(tab));},this);},createTab:function browser_createTab(url,iframe,tab){if(!iframe){iframe=document.createElement('iframe');iframe.mozbrowser=true;iframe.setAttribute('mozallowfullscreen',true);iframe.classList.add('browser-tab');if(url){iframe.setAttribute('src',url);}}
iframe.style.top='-999px';iframe.setAttribute('mozasyncpanzoom','true');iframe.setAttribute('remote','true');if(tab){tab.dom=iframe;}else{tab={id:'tab_'+this.tabCounter++,dom:iframe,url:url||null,title:null,loading:false,screenshot:null,security:null};}
this.setVisibleWrapper(tab,false);this.bindBrowserEvents(iframe,tab);this.tabs[tab.id]=tab;this.frames.appendChild(iframe);return tab.id;},deleteTab:function browser_deleteTab(id){var tabIds=Object.keys(this.tabs);if(this.tabs[id].dom)
this.tabs[id].dom.parentNode.removeChild(this.tabs[id].dom);delete this.tabs[id];ModalDialog.clear(id);AuthenticationDialog.clear(id);if(this.currentTab&&this.currentTab.id===id){var newTab=tabIds.indexOf(id);if(newTab===tabIds.length-1){newTab-=1;}
this.selectTab(Object.keys(this.tabs)[newTab]);}},showNewTabAnimation:function browser_showNewTab(showTabCompleteFun){var ul=this.tabsList.childNodes[0];var li=document.createElement('li');li.innerHTML='<a><img /><span>'+_('new-tab')+'</span></a>';li.style.height='0px';li.style.transition='height 0.2s ease-in';ul.insertBefore(li,ul.childNodes[0]);li.addEventListener('transitionend',function(){setTimeout(showTabCompleteFun,100);});li.clientTop;li.style.height='';},hideCurrentTab:function browser_hideCurrentTab(){var tab=this.currentTab;this.setTabVisibility(tab,false);this.throbber.classList.remove('loading');},selectTab:function browser_selectTab(id){this.currentTab=this.tabs[id];if(this.currentTab.crashed)
this.reviveCrashedTab(this.currentTab);this.setUrlBar(this.currentTab.title);this.updateSecurityIcon();this.refreshButtons();if(id==this.FIRST_TAB&&this.currentTab.url==null){this.showStartscreen();}else{this.hideStartscreen();}},switchScreen:function browser_switchScreen(screen){if(this.currentScreen===this.TABS_SCREEN){this.screenSwipeMngr.gestureDetector.stopDetecting();}
if(this.currentScreen!==screen){document.body.classList.remove(this.currentScreen);this.previousScreen=this.currentScreen;this.currentScreen=screen;document.body.classList.add(this.currentScreen);}},showStartscreen:function browser_showStartscreen(){this.startscreen.classList.remove('hidden');Places.getTopSites(this.MAX_TOP_SITES,null,function(places){this.showTopSiteThumbnails(places);this.loadRemaining();}.bind(this));},_topSiteThumbnailObjectURLs:[],clearTopSiteThumbnails:function browser_clearTopSiteThumbnails(){this.topSiteThumbnails.innerHTML='';this._topSiteThumbnailObjectURLs.forEach(function(url){URL.revokeObjectURL(url);});this._topSiteThumbnailObjectURLs=[];},hideStartscreen:function browser_hideStartScreen(){this.startscreen.classList.add('hidden');this.clearTopSiteThumbnails();},showTopSiteThumbnails:function browser_showStartscreenThumbnails(places){this.clearTopSiteThumbnails();var length=places.length;if(length==0){this.noTopSites.classList.remove('hidden');return;}else{this.noTopSites.classList.add('hidden');}
if(length%2&&length>1)
places.pop();if(length==1)
places.push({uri:'',title:''});places.forEach(function processPlace(place){var thumbnail=document.createElement('li');var link=document.createElement('a');var title=document.createElement('span');link.href=place.uri;title.textContent=place.title?place.title:place.uri;if(place.screenshot){var objectURL=URL.createObjectURL(place.screenshot);this._topSiteThumbnailObjectURLs.push(objectURL);link.style.backgroundImage='url('+objectURL+')';}
thumbnail.appendChild(link);thumbnail.appendChild(title);this.topSiteThumbnails.appendChild(thumbnail);},this);},showAwesomeScreen:function browser_showAwesomeScreen(){this.results.classList.add('hidden');this.tabsBadge.innerHTML='';var pageShown=(function(){this.mainScreen.removeEventListener('transitionend',pageShown,true);this.inTransition=false;}).bind(this);this.mainScreen.addEventListener('transitionend',pageShown,true);this.switchScreen(this.AWESOME_SCREEN);this.setUrlButtonMode(this.GO);this.showTopSitesTab();},showPageScreen:function browser_showPageScreen(){if(this.currentScreen===this.TABS_SCREEN){var switchLive=(function browser_switchLive(){this.mainScreen.removeEventListener('transitionend',switchLive,true);this.setTabVisibility(this.currentTab,true);}).bind(this);this.mainScreen.addEventListener('transitionend',switchLive,true);}else{this.setTabVisibility(this.currentTab,true);}
if(this.currentTab.loading){this.setUrlButtonMode(this.STOP);this.throbber.classList.add('loading');}else{var urlButton=this.currentTab.url?this.REFRESH:this.GO;this.setUrlButtonMode(urlButton);this.throbber.classList.remove('loading');}
this.switchScreen(this.PAGE_SCREEN);this.setUrlBar(this.currentTab.title||this.currentTab.url);if(this.currentTab.crashed){this.showCrashScreen();}else{this.hideCrashScreen();}
this.updateTabsCount();this.inTransition=false;},_tabScreenObjectURLs:[],showTabScreen:function browser_showTabScreen(){this.hideCurrentTab();this.tabsBadge.innerHTML='';var multipleTabs=Object.keys(this.tabs).length>1;var ul=document.createElement('ul');this.tabsList.innerHTML='';this._tabScreenObjectURLs.forEach(function(url){URL.revokeObjectURL(url);});this._tabScreenObjectURLs=[];for(var tab in this.tabs){var li=this.generateTabLi(this.tabs[tab],multipleTabs);ul.appendChild(li);}
this.tabsList.appendChild(ul);this.switchScreen(this.TABS_SCREEN);this.screenSwipeMngr.gestureDetector.startDetecting();new GestureDetector(ul).startDetecting();this.inTransition=false;},generateTabLi:function browser_generateTabLi(tab,multipleTabs){var title=tab.title||tab.url||_('new-tab');var a=document.createElement('a');var li=document.createElement('li');var span=document.createElement('span');var preview=document.createElement('div');var text=document.createTextNode(title);if(multipleTabs){var close=document.createElement('button');close.appendChild(document.createTextNode('✕'));close.classList.add('close');close.setAttribute('data-id',tab.id);a.appendChild(close);}
a.setAttribute('data-id',tab.id);preview.classList.add('preview');span.appendChild(text);a.appendChild(preview);a.appendChild(span);li.appendChild(a);if(tab.screenshot){var objectURL=URL.createObjectURL(tab.screenshot);this._tabScreenObjectURLs.push(objectURL);preview.style.backgroundImage='url('+objectURL+')';}
if(tab==this.currentTab){li.classList.add('current');}
return li;},showSettingsScreen:function browser_showSettingsScreen(){this.switchScreen(this.SETTINGS_SCREEN);this.clearHistoryButton.disabled=false;this.clearPrivateDataButton.disabled=false;},showAboutPage:function browser_showAboutPage(){var tab=this.createTab(this.ABOUT_PAGE_URL);this.hideCurrentTab();this.selectTab(tab);this.setTabVisibility(this.currentTab,true);this.updateTabsCount();this.showPageScreen();},handleClearHistory:function browser_handleClearHistory(){var msg=navigator.mozL10n.get('confirm-clear-browsing-history');if(confirm(msg)){Places.clearHistory((function(){this.clearHistoryButton.setAttribute('disabled','disabled');Places.getTopSites(this.MAX_TOP_SITES,null,this.showTopSiteThumbnails.bind(this));var self=this;var tabIds=Object.keys(this.tabs);tabIds.forEach(function(tabId){var tab=self.tabs[tabId];if(tab.dom.purgeHistory){tab.dom.purgeHistory().onsuccess=function(e){if(tab==self.currentTab){self.refreshButtons();}};}});}).bind(this));this.history.innerHTML='';}},clearPrivateData:function browser_clearPrivateData(){var msg=navigator.mozL10n.get('confirm-clear-cookies-and-stored-data');if(confirm(msg)){var request=navigator.mozApps.getSelf();request.onsuccess=(function(){request.result.clearBrowserData();this.clearPrivateDataButton.setAttribute('disabled','disabled');}).bind(this);}},screenSwipeMngr:{TRANSITION_SPEED:1.8,TRANSITION_FRACTION:0.75,DEFAULT_TRANSITION:'transform 0.2s ease-in-out, height 0.2s ease-in-out',gestureDetector:null,browser:null,screen:null,winWidth:null,mousedown:function screenSwipe_mousedown(e){if(this.browser.currentScreen!==this.browser.TABS_SCREEN){return;}
e.preventDefault();this.winWidth=window.innerWidth;this.screen.style.MozTransition='none';},pan:function screenSwipe_pan(e){if(e.detail.absolute.dx<0){return;}
var leftPos=-(this.winWidth-50)+e.detail.absolute.dx;this.screen.style.transform='translate('+leftPos+'px)';},tap:function screenSwipe_tap(e){this.screen.style.MozTransition=this.DEFAULT_TRANSITION;this.browser.showPageScreen();},swipe:function screenSwipe_swipe(e){var fastenough=e.detail.vx>this.TRANSITION_SPEED;var distance=e.detail.start.screenX-e.detail.end.screenX;var farenough=Math.abs(distance)>this.winWidth*this.TRANSITION_FRACTION;this.screen.style.MozTransition=this.DEFAULT_TRANSITION;this.screen.style.transform='';if(farenough||fastenough){this.browser.showPageScreen();return;}}},tabsSwipeMngr:{TRANSITION_SPEED:1.8,TRANSITION_FRACTION:0.50,browser:null,tab:null,id:null,containerWidth:null,mousedown:function tabSwipe_mousedown(e){e.preventDefault();this.isCloseButton=e.target.nodeName==='BUTTON';this.tab=this.isCloseButton?e.target.parentNode:e.target;this.id=this.tab.getAttribute('data-id');this.containerWidth=this.tab.parentNode.clientWidth;if(this.isCloseButton){e.stopPropagation();return;}
this.deleteable=Object.keys(this.browser.tabs).length>1;if(!this.deleteable||this.browser.inTransition){return;}
this.tab.classList.add('active');this.tab.style.MozTransition='';this.tab.style.position='absolute';this.tab.style.width=e.target.parentNode.clientWidth+'px';},pan:function tabSwipe_pan(e){if(!this.deleteable||this.browser.inTransition){return;}
var movement=Math.min(this.containerWidth,Math.abs(e.detail.absolute.dx));if(movement>0){this.tab.style.opacity=1-(movement/this.containerWidth);}
this.tab.style.left=e.detail.absolute.dx+'px';},tap:function tabSwipe_tap(){if(this.browser.inTransition){return;}
if(this.isCloseButton){this.tab.style.position='absolute';this.tab.style.left='0px';this.tab.style.width=this.containerWidth+'px';this.deleteTab(100,this.containerWidth);return;}
this.browser.selectTab(this.id);this.browser.showPageScreen();},swipe:function tabSwipe_swipe(e){if(!this.deleteable||this.browser.inTransition){return;}
var distance=e.detail.start.screenX-e.detail.end.screenX;var fastenough=Math.abs(e.detail.vx)>this.TRANSITION_SPEED;var farenough=Math.abs(distance)>this.containerWidth*this.TRANSITION_FRACTION;if(!(farenough||fastenough)){var time=Math.abs(distance)/this.TRANSITION_SPEED;var transition='left '+time+'ms linear';this.tab.style.MozTransition=transition;this.tab.style.left='0px';this.tab.style.opacity=1;this.tab.classList.remove('active');return;}
var speed=Math.max(Math.abs(e.detail.vx),1.8);var time=(this.containerWidth-Math.abs(distance))/speed;var offset=e.detail.direction==='right'?this.containerWidth:-this.containerWidth;this.deleteTab(time,offset);},deleteTab:function tabSwipe_deleteTab(time,offset){var browser=this.browser;var id=this.id;var li=this.tab.parentNode;var self=this;this.tab.addEventListener('transitionend',function(){li.addEventListener('transitionend',function(e){browser.deleteTab(id);li.parentNode.removeChild(li);if(Object.keys(self.browser.tabs).length===1){var closeButtons=document.getElementsByClassName('close');Array.forEach(closeButtons,function(el){el.parentNode.removeChild(el);});}},true);li.style.MozTransition='height '+100+'ms linear';li.style.height='0px';},true);this.tab.style.MozTransition='left '+time+'ms linear';this.tab.clientTop;this.tab.style.left=offset+'px';}},handleActivity:function browser_handleActivity(activity){switch(activity.source.data.type){case'url':var url=this.getUrlFromInput(activity.source.data.url);if(this.currentTab)
this.hideCurrentTab();this.selectTab(this.createTab(url));this.showPageScreen();break;}}};var Utils={createHighlightHTML:function ut_createHighlightHTML(text,searchRegExp){if(!searchRegExp){return Utils.escapeHTML(text);}
searchRegExp=new RegExp(searchRegExp,'gi');var sliceStrs=text.split(searchRegExp);var patterns=text.match(searchRegExp);if(!patterns){return Utils.escapeHTML(text);}
var str='';for(var i=0;i<patterns.length;i++){str=str+
Utils.escapeHTML(sliceStrs[i])+'<span class="highlight">'+
Utils.escapeHTML(patterns[i])+'</span>';}
str+=Utils.escapeHTML(sliceStrs.pop());return str;},escapeHTML:function ut_escapeHTML(str,escapeQuotes){var span=document.createElement('span');span.textContent=str;span.innerHTML=span.innerHTML.replace(/\s/g,'&nbsp;');if(escapeQuotes)
return span.innerHTML.replace(/"/g,'&quot;').replace(/'/g,'&#x27;');return span.innerHTML;}};window.addEventListener('load',function browserOnLoad(evt){window.removeEventListener('load',browserOnLoad);Browser.init();});function actHandle(activity){if(Browser.hasLoaded){console.log('--- loaded');Browser.handleActivity(activity);}else{console.log('--- nie loaded');Browser.waitingActivities.push(activity);}
activity.postResult({status:'accepted'});}
if(window.navigator.mozSetMessageHandler){window.navigator.mozSetMessageHandler('activity',actHandle);}